// React Bootstrap Component
/*
	-Syntax 
		import moduleName from 'filePath';
*/
import { useContext } from 'react';
import Container from 'react-bootstrap/Container';
import Navbar from 'react-bootstrap/Navbar';
import Nav from 'react-bootstrap/Nav';
import { NavLink } from 'react-router-dom';
import UserContext from '../UserContext';

export default function AppNavBar() {
	const { user } = useContext(UserContext);
  
	return (
	  <Navbar bg="light" expand="lg">
		<Container fluid>
		  <Navbar.Brand href="#home">Zuitt Booking</Navbar.Brand>
		  <Navbar.Toggle aria-controls="basic-navbar-nav" />
		  <Navbar.Collapse id="basic-navbar-nav">
			<Nav className="ml-auto">
			  <Nav.Link as={NavLink} to="/" exact>
				Home
			  </Nav.Link>
			  <Nav.Link as={NavLink} to="/courses" exact>
				Courses
			  </Nav.Link>
			  {(user && user.isAdmin) && ( // Show the link only for admin users
				<Nav.Link as={NavLink} to="/add-course" exact>
				  Add Course
				</Nav.Link>
			  )}
			  {user && user.id !== null ? (
				<>
				  <Nav.Link as={NavLink} to="/profile" exact>
					Profile
				  </Nav.Link>
				  <Nav.Link as={NavLink} to="/logout" exact>
					Logout
				  </Nav.Link>
				</>
			  ) : (
				<>
				  <Nav.Link as={NavLink} to="/login" exact>
					Login
				  </Nav.Link>
				  <Nav.Link as={NavLink} to="/register" exact>
					Register
				  </Nav.Link>
				</>
			  )}
			</Nav>
		  </Navbar.Collapse>
		</Container>
	  </Navbar>
	);
  }

