import { Card, Button } from 'react-bootstrap';
import { useState } from 'react'
import { Link } from 'react-router-dom';
import PropTypes from 'prop-types';

export default function CourseCard({ courseProp }) {

	// Deconstruct the course properties into their own variables
	const { _id, name, description, price } = courseProp;

	// Use the state hook to be able to store state (data) in this component
	// States are used to keep track of information related to individual component
	// Syntax: 
		/*	
			const [getter, setterFunction] = useState(initialGetterValue)
		*/
	// const [count, setCount] = useState(0);
	// const [seats, setSeats] = useState(10);

	// function enroll(){
	// 	if(seats > 0) {
	// 		setCount(count + 1)
	// 		setSeats(seats - 1);
	// 	} else {
	// 		alert("No more seats available")
	// 	}

		
	// }

	return (
		<Card>
			<Card.Body>
				<Card.Title>{name}</Card.Title>
				<Card.Subtitle>Description:</Card.Subtitle>
				<Card.Text>{description}</Card.Text>
				<Card.Subtitle>Price:</Card.Subtitle>
				<Card.Text>Php {price}</Card.Text>
				<Link className="btn btn-primary" to={`/courses/${_id}`} >Details</Link>
			</Card.Body>
		</Card>
	)
}

// Check if the CourseCard component is getting the correct prop types
// PropTypes are used for validating information passed to a component.
CourseCard.propTypes = {
	// The 'shape' method is used to check if a prop object comforms to a specific "shape"
	courseProp: PropTypes.shape({
		// Define the properties and their expected types
		name: PropTypes.string.isRequired,
		description: PropTypes.string.isRequired,
		price: PropTypes.number.isRequired
	})
}